<?php

function sidetracker_make_api_call($endpoint, $payload, $apiKey) {
    session_start();
    $sessionId = $_SESSION['sidetracker_custom_session_id'] ?? null;
    sidetracker_log($sessionId);
    if ($sessionId) {
        array_walk_recursive($payload, function(&$value) use ($sessionId) {
            if ($value === 'session_id') {
                $value = $sessionId;
            }
        });
    }

    if ($sessionId && strpos($endpoint, 'session_id') !== false) {
        $endpoint = str_replace('session_id', $sessionId, $endpoint);
    }

    $httpMethod = 'POST';
    if (strpos($endpoint, 'tracking') !== false && substr($endpoint, -6) === 'update') {
        $httpMethod = 'PUT';
    }

    $args = [
        'body' => wp_json_encode($payload),
        'headers' => [
            'Content-Type' => 'application/json',
            'Authorization' => $apiKey,
        ],
        'method' => $httpMethod,
        'data_format' => 'body',
    ];

    $response = wp_remote_request($endpoint, $args);

    if (is_wp_error($response)) {
        sidetracker_log('API Call failed: ' . $response->get_error_message());
        return null;
    } else {
        sidetracker_log('API Call successful: ' . wp_remote_retrieve_body($response));
        return wp_remote_retrieve_body($response);
    }
}

?>

